using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using RazorPagesDownload.MyCode;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;


//====================================================
//       :
// https://www.interestprograms.ru
//     
//====================================================


namespace RazorPagesDownload.Pages
{
    public class PublicFilesModel : PageModel
    {
        //     .
        public List<FileInfo> ListFiles = new List<FileInfo>();



        public PublicFilesModel(IWebHostEnvironment env)
        {
            //    .
            string pathDirectory = Path.Combine(env.WebRootPath, MyConstants.PublicDownloadDirectory);
     
            //        .
            var di = new DirectoryInfo(pathDirectory);

            //     FileInfo  Refresh      .
            //     , Refresh     .
            ListFiles = di.GetFiles().ToList();
        }



        public async Task<ActionResult> OnPostVirtualAsync(string file)
        {
            return await Task.Run(() =>
            {
                var fi = ListFiles.FirstOrDefault(p => p.Name == file);

                //      .
                fi.Refresh();

                if (fi.Exists == true)
                {

                    var contentType = MyUtility.ContentTypes(fi.Extension);


                    string virtualPath = MyConstants.PublicDownloadDirectory + "/" + file;


                    return File(virtualPath, contentType, file);

                }
                else
                {
                    //    .
                }

                return null;


            });
        }



        public async Task<ActionResult> OnPostStreamAsync(string file)
        {

            return await Task.Run(() =>
            {
                FileInfo fi = ListFiles.FirstOrDefault(p => p.Name == file);

                //      .
                fi.Refresh();

                if (fi.Exists == true)
                {

                    //  .
                    var stream = fi.OpenRead(); //System.IO.File.OpenRead(path);

                    var contentType = MyUtility.ContentTypes(fi.Extension);

                    // 1 
                    return File(stream, contentType, file);

                    // 2 
                    //return new FileStreamResult(stream, contentType)
                    //{
                    //    FileDownloadName = fi.Name
                    //};
                }
                else
                {
                    //    .
                }

                return null;
            });
        }



        public async Task<ActionResult> OnPostBytesAsync(string file)
        {

            FileInfo fi = ListFiles.FirstOrDefault(p => p.Name == file);

            //      .
            fi.Refresh();

            if (fi.Exists == true)
            {

                //   .
                var bytes = await System.IO.File.ReadAllBytesAsync(fi.FullName);

                var contentType = MyUtility.ContentTypes(fi.Extension);

                return new FileContentResult(bytes, contentType)
                {
                    FileDownloadName = file
                };
            }
            else
            {
                //    .
            }


            return new EmptyResult();
        }

    }
}
